<?php

/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Geeklog 1.3                                                               |
// +---------------------------------------------------------------------------+
// | importnotify.php                                                          |
// |                                                                           |
// | Import email notifications.                                               |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2004 by the following authors:                              |
// |                                                                           |
// | Authors: Dirk Haun - dirk@haun-online.de                                  |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+//
// $Id: importnotify.php,v 1.1.1.1 2004/05/23 15:42:09 dhaun Exp $

require_once ('/path/to/geeklog/public_html/lib-common.php');

require_once ($_CONF['path_system'] . 'classes/timer.class.php');
$_PAGE_TIMER = new timerobject(); 
$_PAGE_TIMER->startTimer();

header ('Content-Type: text/plain');

// try to disable the execution time limit, if possible ...
if (function_exists ('set_time_limit')) {
    @set_time_limit (0);
}

$_TABLES['temp_lookup_thread'] = $_DB_table_prefix . 'yabbtmplookupthreads';


$notifications = 0;
$users = array ();

$result = DB_query ("SELECT id,forum,date FROM {$_TABLES['gf_topic']} WHERE pid = 0 ORDER BY date DESC");
$num = DB_numRows ($result);

for ($i = 0; $i < $num; $i++) {
    $A = DB_fetchArray ($result);

    $lookup = $A['forum'] . ',' . $A['id'];
    $tid = DB_getItem ($_TABLES['temp_lookup_thread'], 'thread',
                       "pid = '$lookup'");

    $file = 'Messages/' . $tid . '.mail';
    if (file_exists ($file)) {
        $email = file ($file);
        $email = array_unique ($email);

        foreach ($email as $e) {
            $e = trim ($e);

            if (empty ($users[$e])) {
                $uid = DB_getItem ($_TABLES['users'], 'uid', "email = '$e'");
                if (empty ($uid) || ($uid < 2)) {
                    continue;
                }
                $users[$e] = $uid;
            } else {
                $uid = $users[$e];
            }

            if ($uid > 1) {
                $date = strftime ('%Y-%m-%d', $A['date']);
                DB_query ("INSERT INTO {$_TABLES['gf_watch']} (forum_id, topic_id, uid, date_added) VALUES ({$A['forum']}, {$A['id']}, $uid, '$date')");
                $notifications++;
            }
        }
    }
}

echo "Added $notifications forum notifications.\n";

$exectime = $_PAGE_TIMER->stopTimer();
echo "\nTime: $exectime seconds.\n";

?>
